const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const approvals = sequelize.define(
    'approvals',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      object_type: {
        type: DataTypes.TEXT,
      },

      object_id: {
        type: DataTypes.INTEGER,
      },

      step: {
        type: DataTypes.INTEGER,
      },

      status: {
        type: DataTypes.ENUM,

        values: ['Pending', 'Approved', 'Rejected'],
      },

      timestamp: {
        type: DataTypes.DATE,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  approvals.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.approvals.belongsTo(db.employees, {
      as: 'approver',
      foreignKey: {
        name: 'approverId',
      },
      constraints: false,
    });

    db.approvals.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.approvals.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.approvals.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return approvals;
};
